#include "bot.h"
/*
#define EID_SHOWUSER            1001
#define EID_JOIN                1002
#define EID_LEAVE               1003
#define EID_WHISPER             1004
#define EID_TALK                1005
#define EID_BROADCAST           1006
#define EID_CHANNEL             1007      
#define EID_USERFLAGS           1009
#define EID_WHISPERSENT         1010
#define EID_CHANNELFULL         1013
#define EID_CHANNELDOESNOTEXIST 1014
#define EID_CHANNELRESTRICTED   1015
#define EID_INFO                1018
#define EID_ERROR               1019
#define EID_EMOTE               1023
#define EID_UNIQUENAME          2010
*/

void Bot::EID_HANDLER(char *data, int *pEID, char *pUSER, unsigned long *pFLAG, char *pTEXT)
{
	char *p;

	if (!data || !pEID || !pUSER || !pFLAG || !pTEXT)  return;

	*pUSER = '\0';
	*pTEXT = '\0';
	*pFLAG = 0;
	*pEID = atoi(data);

	if ((*pEID != 1018) &&	(*pEID != 1013) &&(*pEID != 1007) &&(*pEID != 1014) &&(*pEID != 1015) && (*pEID != 1019))
	{
		char szJunk[128];
		sscanf(data, "%d %s %s %lu", pEID, szJunk, pUSER, pFLAG);
	}

	if(*pEID == 1001)
	{
		char szJunk[128];
		sscanf(data, "%d %s %s %lu %s", pEID, szJunk, pUSER, pFLAG, pTEXT);
		return;
	}

	p = strchr(data, '"');

	if (p)
	{
		strncpy(pTEXT, p+1, 256);
		pTEXT[256-1] = '\0';
		p = strrchr(pTEXT, '"');
		if (p) *p = '\0';
	}
}

void Bot::BVDispatch(char *USER, char *TEXT, unsigned long VAR[])
{ //printf(); %lx for udp will show 0x10 (which is hexidecimal rep of long) but %ld will show 0x16 which is rep of long decimal
	printf("|0x0F-%02lX| ", VAR[0]);

	switch(VAR[0])
	{
		case 0x1:	printf("%lx:%ld %s [%s]\n", VAR[1], (long) VAR[2], USER, TEXT);	break;
		case 0x2:	printf("%lx:%ld %s [%s]\n",VAR[1], (long) VAR[2], USER, TEXT);	break;
		case 0x3:	printf("%lx:%ld %s has left\n",VAR[1], (long) VAR[2], USER);	break;
		case 0x4:	printf("FROM: %s · %s\n", USER, TEXT);				break;
		case 0x5:	printf("%lx:%ld %s · %s\n", VAR[1], (long) VAR[2], USER, TEXT);	break;
		case 0x6:	printf("%s · %s\n", Server, TEXT);				break;
		case 0x7:	printf("%lu: Channel: %s\n", VAR[1],TEXT);			break;
		case 0x9:	printf("%lx:%ld %s [%s]\n", VAR[1], (long) VAR[2], USER, TEXT);	break;
		case 0xA:	printf("TO: %s · %s\n", USER, TEXT);				break;
		case 0xD:	printf("%s · %s\n", Server, TEXT);				break;
		case 0xE:	printf("%s · %s\n", Server, TEXT);				break;
		case 0xF:	printf("%s · %s\n", Server, TEXT);				break;
		case 0x12:	printf("%s · %s\n", Server, TEXT);				break;
		case 0x13:	printf("%s · %s\n", Server, TEXT);				break;
		case 0x17:	printf("%lx:%ld %s %s\n", VAR[1], (long) VAR[2], USER, TEXT);	break;
		case 0x18:	printf("%s · %s\n", USER, TEXT);				break;
		case 0x19:	printf("%s · %s\n", USER, TEXT);				break;
	}
}

void Bot::CDispatch(char *data)
{
	int EID;
	unsigned long FLAG;//u_long is unsigned long
	char USER[128] = "";
	char TEXT[256] = "";

	EID_HANDLER(data, &EID, USER, &FLAG, TEXT);

	switch (EID)
	{
		case 1001:	EID_USER(USER, FLAG, TEXT);	break;
		case 1002:	EID_JOIN(USER, FLAG, TEXT);	break;
		case 1003:	EID_LEFT(USER, FLAG, TEXT);	break;
		case 1004:	EID_PMSG(USER, FLAG, TEXT);	break;
		case 1005:	EID_TALK(USER, FLAG, TEXT);	break;
		case 1006:	break;
		case 1007:	EID_CHAN(USER, FLAG, TEXT);	break;
		case 1009:	EID_FLAG(USER, FLAG, TEXT);	break;
		case 1010:	break;
		case 1018:	EID_INFO(USER, FLAG, TEXT);	break;
		case 1019:	break;
		case 1023:	break;
		case 2000:	return;
		case 2010:	EID_NAME(USER, FLAG, TEXT);	break;
		default:	printf("UNHANDLED PACKET: %s\n", data);	return;
	}

	if(PSB == SB) CVDispatch(data, EID, USER, FLAG, TEXT);
}

void Bot::CVDispatch(char *data, int EID, char *USER, unsigned long FLAG, char *TEXT)
{
	printf("|%d| ", EID);

	switch (EID)
	{
		case 1001:	printf("%s %s\n", TEXT, USER);		break;
		case 1002:	printf("%s\n",USER);			break;
		case 1003:	printf("%s has left\n", USER);		break;
		case 1004:	printf("FROM: %s · %s\n", USER, TEXT);	break;
		case 1005:	printf("%s · %s\n", USER, TEXT);	break;
		case 1006:	printf("%s · %s\n", Server, TEXT);	break;
		case 1007:	printf("Channel: %s\n", TEXT);		break;
		//add 1009
		case 1010:	printf("TO: %s · %s\n", USER, TEXT);	break;
		case 1018:	printf("%s\n", TEXT);			break;
		case 1019:	printf("%s\n", TEXT);			break;
		case 1023:	printf("%s · %s\n", USER, TEXT);	break;
		case 2010:	printf("CONNECTED AS: %s\n", USER);	break;
	}
}

void Bot::EID_USER(char *USER, unsigned long FLAG, char *TEXT)
{
	++CLIST;
}

void Bot::EID_JOIN(char *USER, unsigned long FLAG, char *TEXT)
{
	++CLIST;
}

void Bot::EID_FLAG(char *USER, unsigned long FLAG, char *TEXT)
{

}

void Bot::EID_LEFT(char *USER, unsigned long FLAG, char *TEXT)
{
	--CLIST;
}

void Bot::EID_TALK(char *USER, unsigned long FLAG, char *TEXT)
{
	if( (!strncmp(USER,Master,strlen(Master))) && (!strncmp(TEXT,CMD,1)) )
	{
		Mandate(USER,TEXT,false);
	}
}

void Bot::EID_CHAN(char *USER, unsigned long FLAG, char *TEXT)
{    
	CLIST = 0;
}

void Bot::EID_PMSG(char *USER, unsigned long FLAG, char *TEXT)
{

}

void Bot::EID_INFO(char *USER, unsigned long FLAG, char *TEXT)
{
	if(strstr(TEXT,"currently"))
	{
		char *tmp;
		
		tmp = strtok(TEXT, " ");
		tmp = strtok(NULL, " ");
		tmp = strtok(NULL, " "); 
		tmp = strtok(NULL, " ");
		place = atoi(tmp) + 1;
	}
}

void Bot::EID_NAME(char *USER, unsigned long FLAG, char *TEXT)
{   

}
